using FastEndpoints;
using Knots.DTO.User;
using Microsoft.EntityFrameworkCore;

namespace Knots.Endpoints.User;


public class PatchUsernameEndpoint(KnotsDbContext knotsDbContext) : Endpoint<UpdateUsernameDto>
{
    public override void Configure()
    {
        Patch("/users/{@Id}/username/", x => new {x.Id});
        AllowAnonymous();
    }

    public override async Task HandleAsync(UpdateUsernameDto req, CancellationToken ct)
    {
        Models.User? databaseUser = await knotsDbContext.Users.SingleOrDefaultAsync(x => x.Id == req.Id, cancellationToken: ct);

        if (databaseUser is null)
        {
            await Send.NotFoundAsync(ct);
            return;
        }
        
        databaseUser.Username = req.Username;
        await knotsDbContext.SaveChangesAsync(ct);
        await Send.NoContentAsync(ct);
    }
}